/**
 * @author Immo Schulz-Gerlach
 * @author Markus Muckhoff
 * Basisversion von Immo Schulz-Gerlach
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.0
 */
import java.awt.*;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.Entity;

public class RauteMitLabel extends com.umlet.element.custom.Decision {

	//*******************************************************************************************
	//this is copied from com.umlet.element.custom.Decision
	private void oldpaintBig(Graphics g) {
		Graphics2D g2=(Graphics2D) g;
		g2.setFont(Constants.getFont());
		g2.setColor(_activeColor);
		Constants.getFRC(g2);
		
		//inserted a second border
		g2.drawLine(this.getWidth()/2,0 + 1,this.getWidth() - 1,this.getHeight()/2);
		g2.drawLine(this.getWidth()/2,0 + 1, 1,this.getHeight()/2);
		g2.drawLine(1,this.getHeight()/2,this.getWidth()/2,this.getHeight()  - 1);
		g2.drawLine(this.getWidth()-2,this.getHeight()/2,this.getWidth()/2-1,this.getHeight() - 1);
		
		g2.drawLine(this.getWidth()/2,0 + 2,this.getWidth() - 2,this.getHeight()/2);
		g2.drawLine(this.getWidth()/2,0 + 2, 2,this.getHeight()/2);
		g2.drawLine(2,this.getHeight()/2,this.getWidth()/2,this.getHeight()  - 2);
		g2.drawLine(this.getWidth()-3,this.getHeight()/2,this.getWidth()/2-1,this.getHeight() - 2);
	}
	//*******************************************************************************************
	
	//*******************************************************************************************
	//this is copied from com.umlet.element.custom.Decision
	private void oldpaintNormal(Graphics g) {
		Graphics2D g2=(Graphics2D) g;
		g2.setFont(Constants.getFont());
		g2.setColor(_activeColor);
		Constants.getFRC(g2);

		g2.drawLine(this.getWidth()/2,0,this.getWidth(),this.getHeight()/2);
		g2.drawLine(this.getWidth()/2,0,0,this.getHeight()/2);
		g2.drawLine(0,this.getHeight()/2,this.getWidth()/2,this.getHeight());
		g2.drawLine(this.getWidth()-1,this.getHeight()/2,this.getWidth()/2-1,this.getHeight());
	}
	//*******************************************************************************************
	
  // Change this method if you want to edit the graphical 
  // representation of your custom element.
  public void paint(Graphics g) {

    //super.paint(g);
    // Some unimportant initialization stuff; setting color, font 
    // quality, etc. You should not have to change this.
    Graphics2D g2=(Graphics2D) g; g2.setFont(Constants.getFont());
    Constants.getFRC(g2);

    Vector tmp=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
		
		Composite[] composites = colorize(g2); //LME: enable colors
		g2.setColor(_activeColor); 
		
		this.oldpaintNormal(g);
		
		int i=0;
		while(i<tmp.size())
		{
			String StrTmp = (String) tmp.elementAt(i);
			if(StrTmp.equals("boldBorder"))
			{
				this.oldpaintBig(g);
				tmp.remove(i);
			}
			else
				i++;
		}
		
    int yPos=(this.getHeight()/2)+ (Constants.getFontsize()/3);
    if (tmp.size()>0) {
      String s=(String)tmp.elementAt(0);
      Constants.write(g2,s,this.getWidth()/2, yPos, true);
    }
  }

  public int getPossibleResizeDirections() {
    // Remove from this list the borders you don't want to be resizeable.
    return Constants.RESIZE_TOP | Constants.RESIZE_LEFT | Constants.RESIZE_BOTTOM | Constants.RESIZE_RIGHT;
    //return 0;
  }
}
