// Some import to have access to more Java features
import java.awt.*;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.Entity;

public class SubsystemState extends com.umlet.element.custom.State {

	public void paint(Graphics g) {
		super.paint(g);
		
		Graphics2D g2=(Graphics2D) g;
		g2.setFont(Constants.getFont());
		g2.setColor(_activeColor);
		Constants.getFRC(g2);
		
		int w = Constants.getPixelWidth(g2,"x");
		//w ist Breite eines jeden Segments (alle gleich lang). Gesamtbreite und -hhe: 2*w
		int x3=this.getWidth()-Constants.getDistLineToText()*3;
		int x2=x3-w;
		int x1=x2-w;
		int y3=this.getHeight()-Constants.getDistLineToText()*2;
		int y2=y3-w;
		int y1=y2-w;
		
		g2.drawLine(x1,y2,x1,y3);
		g2.drawLine(x1,y2,x3,y2);
		g2.drawLine(x2,y1,x2,y3);
		g2.drawLine(x3,y2,x3,y3);
	}

}
